<template>
  <v-dialog v-model="dialog" max-width="600px" @keydown.esc="close()" @click:outside="close()">
    <v-row justify="center" no-gutters>
      <v-card style="width: 100%">
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-folder-swap</v-icon
              ><b>Mover subárea</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" style="position:absolute; right: 15px" color="red" @click="close"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text>
          <v-card-actions>
            <v-row class="mt-n2" no-gutters>
              <v-col cols="12" class="cardStyle">
                <v-card tile class="subtitle-1" elevation="0">
                  <v-row justify="center">
                    <span class="primary--text"
                      >Áreas disponíveis para mover <b>{{ selectedArea.name }}</b></span
                    >
                  </v-row>
                  <v-row justify="center">
                    <span style="font-size:0.8rem"
                      >Clique no nome da área para abrir suas filhas.</span
                    >
                  </v-row>

                  <v-card-text class="scrollForm my-2">
                    <v-row justify="center">
                      <v-col cols="12" class="contentP">
                        <v-treeview :items="knowledgeArea" :open="open" item-key="id">
                          <!-- PREPEND -->
                          <template v-slot:prepend="{ item, open }">
                            <v-icon color="grey" v-if="open && !item.noData"
                              >mdi-folder-open</v-icon
                            >
                            <v-icon color="grey" v-if="!open && !item.noData">mdi-folder</v-icon>
                          </template>
                          <!-- LABEL -->
                          <template slot="label" slot-scope="{ item }">
                            <span
                              v-if="!item.noData"
                              style="cursor: pointer"
                              @click="openNode(item)"
                              >{{ item.name }}</span
                            >
                            <span class="grey--text text--darken-1" v-else
                              ><i>{{ item.name }}</i></span
                            >
                          </template>
                          <!-- Actions -->
                          <template slot="append" slot-scope="{ item }">
                            <div v-if="!item.noData" class="supportIconsTable">
                              <v-tooltip color="primary" bottom>
                                <template v-slot:activator="{ on }">
                                  <v-btn
                                    v-on="on"
                                    :disabled="item.id == father.id"
                                    @click.stop="handleMoveTo(item)"
                                    icon
                                    x-small
                                  >
                                    <v-icon>mdi-folder-swap</v-icon>
                                  </v-btn>
                                </template>
                                <span style="font-size:0.8rem"
                                  >Mover para <b>{{ item.name }}</b></span
                                >
                              </v-tooltip>
                            </div>
                          </template>
                        </v-treeview>
                      </v-col>
                    </v-row>
                  </v-card-text>
                </v-card>
              </v-col>
            </v-row>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-row>
    <!-- Confirma mover -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="moveAreaReq"
    />
  </v-dialog>
</template>

<script>
import Area from '../../../services/questionBank'
export default {
  name: 'MoveArea',
  props: {
    dialog: {
      type: Boolean,
      default: false,
    },
    area: {
      type: Array,
      default: () => {
        return []
      },
    },

    selectedArea: { type: Object, default: () => {} },
  },
  data: () => ({
    moveTo: '',
    knowledgeArea: [],
    open: [],
    tempChildren: [],
    father: '',
    alert: {
      status: false,
      icon: 'mdi-folder-swap',
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
  }),
  async created() {
    this.knowledgeArea = JSON.parse(JSON.stringify(this.area))
    this.findFather(this.knowledgeArea, this.selectedArea.id)
    this.knowledgeArea = this.filterToDelete(this.knowledgeArea, this.selectedArea.id)
  },

  methods: {
    close() {
      this.$emit('closeDialog')
      this.moveTo = ''
    },

    //v-tree open - método front para abrir as categorias
    async openNode(item) {
      let check = false
      let index = -1
      //1º verifica se já está aberto
      for (let i = 0; i < this.open.length; i++) {
        if (this.open[i] == item.id) {
          check = true
          index = i
          break
        }
      }
      await this.readChildren(item)
      if (check && item.children.length > 0) this.open.splice(index, 1)
      if (!check && item.children.length > 0) this.open.push(item.id)
    },

    async readChildren(parent) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.readChildrenArea(parent.id)
        if (req.success) {
          this.tempChildren =
            req.data.children.length > 0
              ? req.data.children
              : [{ id: `${Math.random()}`, name: 'Não possui subcategorias.', noData: true }]
          this.refreshNodeAfterOpen(this.knowledgeArea, parent.id)
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    refreshNodeAfterOpen(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.refreshNodeAfterOpen(item.children, id)
        if (item.id == id) {
          if (!item.children) {
            this.$set(item, 'children', [])
          }
          // item.children = this.tempChildren
          item.children = this.filterToDelete(this.tempChildren, this.selectedArea.id)
        }
        return item.id
      })
      return r
    },

    filterToDelete(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToDelete(item.children, id)
        return item.id != id
      })
      return r
    },

    findFather(data, id) {
      data.forEach((item) => {
        if (item.children) {
          item.children.forEach((check) => {
            if (check.id == id) this.father = item
          })
          item.children = this.findFather(item.children, id)
        }
      })
    },

    handleMoveTo(item) {
      this.moveTo = item
      this.alert.status = true
      this.alert.message = `Você deseja <b>mover</b> a área <b>${this.selectedArea.name}</b> para <b>${item.name}</b>? `
    },

    async moveAreaReq() {
      console.log(this.father)
      let data = { areaId: this.selectedArea.id, from: this.father.id, to: this.moveTo.id }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.moveSubArea(data)
        if (req.success) {
          this.alert.status = false
          this.$emit('movedArea')
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Área foi <b>movida</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.alert.status = false
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Atenção, <b>não foi possível mover</b> a área de conhecimento.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>
